-- $Id: algmorph.ts,v 1.2 2007/05/28 19:09:38 cocoa Exp $
-- Example/Test suite for algmorph.cpkg

/*

Source CocoaPackagePath() + "/contrib/algmorph.ts";
TSL.Do();

*/

Alias TSL := $ts/ts_lib;
TSL.Initialize();

-------------------------------
-- TEST:
Test := Record[Id = 1, Descr = "ex"];

Test.Input := "
    Rxyz ::= Q[x,y,z];
    Rab  ::= Q[a,b];

    Use Rab;
    -- like RMap + the ring names
    Phi := Alg.Map(""Rxyz"", ""Rab"", [a+1, ab+3, b^2]);

    -- or, in any ring
    Use Z/(2)[w]; Phi := Alg.Map(""Rxyz"", ""Rab"", Rab::[a+1, ab+3, b^2]);

    Alg.Ker(Phi);
    Alg.IsInjective(Phi);
    Alg.IsSurjective(Phi);

    Use Rab;
    Alg.IsInImage(a^2, Phi);
    Alg.PreImage(a^2, Phi);
    Alg.Image(Rxyz :: (x^2 - 2x + 1), Phi);
";

Test.ExpectedOutput :=
"Rxyz :: Ideal(x^2z - y^2 - 2xz + 6y + z - 9)
-------------------------------
FALSE
-------------------------------
FALSE
-------------------------------
TRUE
-------------------------------
Rxyz :: x^2 - 2x + 1
-------------------------------
a^2
-------------------------------
";
TSL.RegisterTest(Test);

-------------------------------
-- TEST:
Test := Record[Id = 2, Descr = "ex"];

Test.Input := "
    -- linear maps
    M := Mat[[1,2,3],[2,3,4],[1,0,1]];
    Det(M);  -- invertible

    Use Qx13 ::= Q[x[1..3]];
    L := [ Sum([ Row[I]x[I] | I In 1..Len(Row)]) | Row In M ];
    Psi := Alg.Map(""Qx13"", ""Qx13"", L);  -- linear map defined by M
    Alg.IsInjective(Psi);
    Alg.IsSurjective(Psi);

    Inv := [Alg.PreImage(x[I], Psi) | I In 1..3];
    MM := Mat([ [ CoeffOfTerm(x[I], Inv[J]) | I In 1..3 ]
	      | J In 1..3]);
    M * MM;
";

Test.ExpectedOutput :=
"-2
-------------------------------
TRUE
-------------------------------
TRUE
-------------------------------
Mat([
  [1, 0, 0],
  [0, 1, 0],
  [0, 0, 1]
])
-------------------------------
";
TSL.RegisterTest(Test);

-------------------------------
-- TEST:
Test := Record[Id = 3, Descr = "ex"];

Test.Input := "
    Use Q[x,y,z];
    -- elementary symmetric polynomials
    S0 := 1;  S1 := x+y+z;  S2 := xy + xz + yz;  S3 := xyz;
    SA := Alg.SubAlgebra([S0, S1, S2, S3]);
    -- x^4 + y^4 + z^4 is a symmetric polynomial
    Alg.IsInSubAlgebra(x^4 + y^4 + z^4, SA);
    Repr := Alg.SubAlgebraRepr(x^4 + y^4 + z^4, SA);
    Repr;
    Image(Repr, RMap([S0, S1, S2, S3]));
    -- equivalent to
    Alg.Image(Repr, SA);

    Alg.IsInSubAlgebra(x^14 + y^14 + z^14, SA);
";

Test.ExpectedOutput :=
"TRUE
-------------------------------
SubAlgebraRing :: x[2]^4 - 4x[2]^2x[3] + 2x[3]^2 + 4x[2]x[4]
-------------------------------
x^4 + y^4 + z^4
-------------------------------
x^4 + y^4 + z^4
-------------------------------
TRUE
-------------------------------
";
TSL.RegisterTest(Test);

